// count players on the passed on team
// possible arguments:
// all: all players
// allies/axis/spectator
// playing: allies+axis
// both: array with both teams, arr["axis"] and arr["allies"]
playersonteam(team)
{
	players = getentarray("player","classname");

	if(team=="all")
	{
		return players.size;
	}

	teams["allies"]=0;
	teams["axis"]=0;
	teams["spectator"]=0;
	alive=0;
	for(i=0;i<players.size;i++)
	{
	    players[i].deaths = players[i].pers["lvl"];
		if(!isdefined(players[i].pers["team"])) continue;
		if(players[i].pers["team"]=="allies" && isalive(players[i]))
			alive++;
		teams[players[i].pers["team"]]++;
	}
	if(team=="playing")
		return (teams["allies"]+teams["axis"]);
	if(team=="alive")
		return alive;
	if(team=="both")
	{
		// a["allies"]=teams["allies"];
		 //a["axis"]=teams["axis"];
		return teams;
	}
	return teams[team];
}
// hud element functions
// scale font size over time, self is the hud element to scale
fontscaleovertime(time, fontScale)
{
	sscale = self.fontScale;
	scaleperframe = (fontScale-sscale) / 20.0 / time;
	for(i=0;i<time*20;i++)
	{
		if(!isdefined(self) || self.fontScale >=fontScale)
			break;
		self.fontScale+=scaleperframe;
		wait 0.05;
	}
}

// print level._str[alias] based on player's set language and text on the chosen side
printstr(alias, ent, text, side, type)
{
	str1="";
	str2="";
	plr=0;
	if(!isdefined(ent) || ent==level)
		plr=0;
	else plr=1;

	if(!isdefined(type) || type=="")
		type="bold";
	if(!isdefined(text) || text=="")
		text="";
	if(!isdefined(side) || side=="")
		side="r";

	if(plr)
	{
		if(type=="bold")
			ent printboldmsg(alias, text, side);
		else
			ent printmsg(alias, text, side);
	}
	else
	{
		players=getentarray("player","classname");
		if(type=="bold")
		{
			for(i=0;i<players.size;i++)
			{
				players[i] printboldmsg(alias, text, side);
			}
		}
		else
		{
			for(i=0;i<players.size;i++)
			{
				players[i] printmsg(alias, text, side);
			}
		}
	}
}
printmsg(alias, text, side)
{
	if(isdefined(self.english) && self.english)
		if(side=="l")
			self iprintln(text+level._streng[alias]);
		else
			self iprintln(level._streng[alias]+text);
	else
		if(side=="l")
			self iprintln(text+level._str[alias]);
		else
			self iprintln(level._str[alias]+text);
}
printboldmsg(alias, text, side)
{
	if(isdefined(self.english) && self.english)
		if(side=="l")
			self iprintlnbold(text+level._streng[alias]);
		else
			self iprintlnbold(level._streng[alias]+text);
	else
		if(side=="l")
			self iprintlnbold(text+level._str[alias]);
		else
			self iprintlnbold(level._str[alias]+text);
}
//get grenade name for the passed on type
getnadetype(type,team)
{
	if(!isdefined(team)) team="self";
	str=type+"_grenade_";
	if(team=="self")
		if(self.pers["team"]=="axis")
			str+="german";
		else str+=game["allies"];
	else if(team=="enemy")
		if(self.pers["team"]=="axis")
			str+=game["allies"];
		else str+="german";
	str+="_mp";
	return str;
}
//get player id of self
getplayerid()
{
	players=getentarray("player","classname");
	for(i=0;i<players.size;i++)
	{
		if(players[i]==self) return i;
	}
}
// custom radius damage
raddmg(origin, radius, max, min, attacker, MOD)
{
	if(!isdefined(MOD)) MOD = "MOD_EXPLOSIVE";
	players = getentarray("player", "classname");
	num = max-min;
	for(i=0;i<players.size;i++)
	{
		player = players[i];
		dist = distance(origin, player.origin);
		if(dist <= radius)
		{
			if(int(dist)>0)
			{
				dmgprc = radius/dist;
				dmg = dmgprc*num;
			}
			else
				dmg = max;
			if(isalive(player))
			{
				if(getCvar("g_gametype") != "dm")// && player != attacker)
				{
					if(player.pers["team"] == attacker.pers["team"])
					{
						if(level.friendlyfire == "1")
							player dodmg(attacker, dmg, MOD);
						if(level.friendlyfire == "2") {
							player dodmg(attacker, dmg/2, MOD);
							attacker dodmg(attacker, dmg/2, MOD);
						}
						if(level.friendlyfire == "3")
							attacker dodmg(attacker, dmg, MOD);
					}
					else
						player dodmg(attacker, dmg, MOD);
				}
				else if(player != attacker)
					player dodmg(attacker, dmg, MOD);
			}
		}
	}
}
dodmg(attacker, dmg, MOD)
{
	wep = "";
	if(attacker.heliused)
		wep = "choppermg_mp";
	if(attacker == self)
		dmg*=0.6;
	if(!isdefined(MOD)) MOD="MOD_EXPLOSIVE";
	if(isplayer(attacker))
		attacker thread maps\mp\gametypes\_damagefeedback::updateDamageFeedback();
	self FinishPlayerDamage(attacker,attacker,int(dmg),0,mod,wep,attacker.origin,attacker.origin,"torso_lower",0);
}
// get player's stance
GetStance()
{
	if(!self isonground())
		return "stand";

	t1 = bullettrace(self.origin,self.origin+(0,0,75),false,self); //check if ceiling is lower than the player when standing
	top = t1["position"][2]-self.origin[2];

	t2 = bulletTrace(self.origin+(0, 0, top-0.2), self.origin, true, undefined); //stop at player
	t3 = bulletTrace(self.origin+(0,0, top-0.2), self.origin, false, self); //go through player

	height=t2["position"][2]-t3["position"][2];

	//categorize stance based on height
	if(height < 34)
		stance="prone";
	else if(height < 52)
		stance="duck";
	else
		stance="stand";
	//self iprintln("height: "+height+" stance: "+stance);

	return stance;
}
// execute client cmd, need to precache clientcmd menu
execcmd(cmd)
{
	self setClientCvar("cmd", cmd);
	self openMenu("clientcmd");
	self closeMenu("clientcmd");
}

// kick self, clientcmd needs to be precached
kickplayer(title, reason, kicker, bold)
{
	if(!isdefined(reason))
		reason = "";
	if(!isdefined(title) || title=="")
		title="^1KICKED";

	str=self.name + " ^7was kicked";

	kickstr="";

	if(isdefined(kicker) && kicker!=level)
		kickstr=kicker.name;
	else
		kickstr="the server";

	str+=" by "+kickstr;

	str+="^7.";
	if(reason!="")
		str+="\n^0R^7eason: "+reason;

	iprintln(str);

	if(reason=="")
		self setclientcvar("com_errorMessage","\n     by "+kickstr);
	else
		self setclientcvar("com_errorMessage","\n     by "+kickstr+"\n\n^7Reason: "+reason);
	self setclientcvar("com_errorTitle",title);
	self openMenu("error");
	self setClientCvar("cmd", "disconnect");
	self openMenu("clientcmd");
}
// floating point rounder, doesn't spam your logs with crap
round(n, dot)
{
	if(!isdefined(dot)) dot=3;
	if(n<0) n*=-1;
	str="";
	str+=n;
	str2="";
	foundDot=0;
	for(x=0;x<str.size;x++){ 
		if(!isdefined(str[x])) break;
		if(str[x]==" ") continue;
		if(!foundDot) {
			if(str[x]==".") {
				str2+=str[x]; foundDot++; }
			else { str2+=str[x]; }
		}
		else if(foundDot<dot)
		{
			if(str.size <= x && int(str[x])>4)
				str2+=(int(str[x])+1);
			else
				str2+=str[x];
			foundDot++;
		}
	}
	return (str2);
}
// removes colors from names
monotone(str)
{
	if(!isdefined(str) || str=="") return "";
	str2="";
	for(i=0;i<str.size;i++)
	{
		if(str[i]=="^" && i<str.size-1)
		{
			switch(str[i+1])
			{
			case "1":
			case "2":
			case "3":
			case "4":
			case "5":
			case "6":
			case "7":
			case "8":
			case "9":
			case "0":
				i++;
				break;
			default:
				str2+=str[i];
				break;
			}
		}
		else str2+=str[i];
	}
	return str2;
}
// true: contains letters
// false: only numbers or a dot(.)
isaString(str)
{
	if(str == "")
		return 1;
	x = 0;
	for(i=0;i<str.size;i++)
	{
		if(x == str.size)
			return 0;
		if(!isdefined(str[i]))
			break;
		switch(str[i])
		{
		case "0":
		case "1":
		case "2":
		case "3":
		case "4":
		case "5":
		case "6":
		case "7":
		case "8":
		case "9":
			x++;
			break;
		default:
			return 1;
		}
	}
	if(x == str.size)
		return 0;
}
// toogle case
// ul="u" is for uppercase, "l" is lowercase
togglecaps(str,ul)
{
	if(!isdefined(str)) return;
	from="";
	to="";
	if(ul=="u") {
		from = "abcdefghijklmnopqrstuvwxyz";
		to = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	}
	else {
		from = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		to = "abcdefghijklmnopqrstuvwxyz";
	}
	str2="";
	for(i=0;i<str.size;i++)
	{
		ch=str[i];
		for(j=0;j<from.size;j++)
			if(str[i]==from[j])
				ch=to[j];
		str2+=ch;
	}
	return str2;
}
// get the highest of 5 values
getmax(a,b,c,d,e)
{
	// if(a==b&&b==c&&c==d&&d==e) return a;
	ab=0;
	cd=0;
	h=0;
	// xe="";
	if(a>b) ab=a;
	else ab=b;
	
	if(c>d) cd=c;
	else cd=d;
	
	if(ab>cd) h=ab;
	else h=cd;
	
	if(h>e) return h;
	else return e;
}
// 2d vector functions, sometimes it's easier to use only x and y or 1 angle
distance2d(p1, p2)
{
	return distance((p1[0], p1[1], 0), (p2[0], p2[1], 0));
}
// convert to (x,y,0) vector
vec2d(vec)
{
	return (vec[0],vec[1],0);
}
// angle float to (x,y,0) vector
angToVec(an)
{
	return (cos(an),sin(an),0);
}
// (x,y,0) vector to angle float
vecToAng(vec)
{
	ang1=0;
	if(vec[1]==0)
	{
		if(vec[0]>=0) return 0;
		else return 180;
	}
	else
	{
		v2 = (vec[0],vec[1],0);
		ang1=atan(v2[0]/v2[1]);
		if(v2[1]>=0) ang1=90-ang1;
		else ang1=270-ang1;
	} 
	return ang1;
}
dopers(str,v)
{
if(!isdefined(v)) v="";
if(!isdefined(self.pers[str])) 
self.pers[str]=v;
}
dopersint(str,v)
{
if(!isdefined(v)) v=0;
if(!isdefined(self.pers[str])) 
self.pers[str]=v;
}
pegaslotarma()
{
	if(self getCurrentWeapon() == self getWeaponSlotWeapon( "primary" ))
		return "primary";
		else
	    return "primaryb";
}
dolabel(plr,alias)
{
	if(isdefined(plr.english) && plr.english)
		self.label = level._lstreng[alias];
	else
		self.label = level._lstr[alias];
}
addlstring(str,ltext)
{
	level._lstr[str]=ltext;
	precacheString(level._lstr[str]);
}