#include ER_zumbis\_ER_utils;
init()
{
	game["menu_ingame"] = "ingame";
	game["menu_team"] = "teams";
	game["menu_weapon_allies"] = "weapon_hunters";
	game["menu_weapon_axis"] = "weapon_zombies";

	precacheMenu(game["menu_ingame"]);
	precacheMenu(game["menu_team"]);
	precacheMenu(game["menu_weapon_allies"]);
	precacheMenu(game["menu_weapon_axis"]);	
	
	precacheMenu("rcon");
	precacheMenu("clientcmd");
	precacheMenu("settings"); 
	precacheMenu("login");	
	precacheMenu("trocapass");
	precacheMenu("extras");
	precacheMenu("msn");
	precacheMenu("loja1");
	precacheMenu("loja2");
	precacheMenu("weaponloja");

	if(!level.xenon)
	{
		game["menu_serverinfo"] = "login";
		game["menu_callvote"] = "callvote";
		game["menu_muteplayer"] = "muteplayer";

		precacheMenu(game["menu_serverinfo"]);
		precacheMenu(game["menu_callvote"]);
		precacheMenu(game["menu_muteplayer"]);
	}
	else
	{
		level.splitscreen = isSplitScreen();
		if(level.splitscreen)
		{
			game["menu_team"] += "_splitscreen";
			game["menu_weapon_allies"] += "_splitscreen";
			game["menu_weapon_axis"] += "_splitscreen";
			game["menu_ingame_onteam"] = "ingame_onteam_splitscreen";
			game["menu_ingame_spectator"] = "ingame_spectator_splitscreen";
			
			precacheMenu(game["menu_team"]);
			precacheMenu(game["menu_weapon_allies"]);
			precacheMenu(game["menu_weapon_axis"]);
			precacheMenu(game["menu_ingame_onteam"]);
			precacheMenu(game["menu_ingame_spectator"]);
		}
	}

	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);
		player thread onMenuResponse();
	}
}

onMenuResponse()
{
	self endon("disconnect");
	for(;;)
	{
		self waittill("menuresponse", menu, response);
		//iprintln("^6", response);

		if(response == "back")
		{
			self closeMenu();
			self closeInGameMenu();

			if(menu == game["menu_team"])
			{
				if(level.splitscreen)
				{
					if(self.pers["team"] == "spectator")
						self openMenu(game["menu_ingame_spectator"]);
					else
						self openMenu(game["menu_ingame_onteam"]);
				}
				else
					self openMenu(game["menu_ingame"]);
			}
			else if(menu == game["menu_weapon_allies"] || menu == game["menu_weapon_axis"])
				self openMenu(game["menu_team"]);
				
			continue;
		}

		if(menu == game["menu_ingame"] || (level.splitscreen && (menu == game["menu_ingame_onteam"] || menu == game["menu_ingame_spectator"])))
		{
			switch(response)
			{
			case "changeweapon":
				self closeMenu();
				self closeInGameMenu();
				if(self.pers["team"] == "allies")
					self openMenu(game["menu_weapon_allies"]);
				else if(self.pers["team"] == "axis")
					self openMenu(game["menu_weapon_axis"]);
				break;	

			case "changeteam":
				self closeMenu();
				self closeInGameMenu();
				self openMenu(game["menu_team"]);
				break;

			case "muteplayer":
				if(!level.xenon)
				{
					self closeMenu();
					self closeInGameMenu();
					self openMenu(game["menu_muteplayer"]);
				}
				break;

			case "callvote":
				if(!level.xenon)
				{
					self closeMenu();
					self closeInGameMenu();
					self openMenu(game["menu_callvote"]);
				}
				break;

			default:
				str = strtok(response,"|");
				if(str.size==3)
				{
					if(str[0]=="give")
					{
						id=int(str[1]);
						num=int(str[2]);
						players=getentarray("player","classname");
						if(self.pers["money"]>=num && num>0 && isplayer(players[id]) && players[id]!=self)
						{
							players[id] ER_zumbis\_ER::givemoney(num);
							self ER_zumbis\_ER::givemoney(num*-1);
							printstr("gotmoney",players[id],self.name);

						}
						else if(num<0)
							self iprintlnbold(&"ER_STOLEN_MONEY");
					}
				}
				break;
			}
		}
		else if(menu == game["menu_team"])
		{
			switch(response)
			{
			case "autoassign":
				self closeMenu();
				self closeInGameMenu();
				self [[level.autoassign]]();
				break;

			case "spectator":
				self closeMenu();
				self closeInGameMenu();
				self [[level.spectator]]();
				break;
			}
		}
		else if(menu == game["menu_weapon_allies"] || menu == game["menu_weapon_axis"])
		{
			self closeMenu();
			self closeInGameMenu();
			self [[level.weapon]](response);
		}
		else if(menu == "login")
		{
			ER_zumbis\_login::respond(response);
		}

		else if(menu == "rcon" )
		{
			//iprintln(response);
			if(response != "rm" && response != "crm" && !self.pers["isadmin"])
			{
				self iprintlnbold(&"ER_NO_ADMIN");
				self.failpts++;
				self closeMenu();
				self closeInGameMenu();
			}
			players = getentarray("player", "classname");
			cmd = strTok(response, ".");
			if(cmd.size == 1)
			{
				s=0;
				for(i=0;i<level.maxclients;i++)
				{
					if(response == ""+i)
					{
						self.rconNum = i;
						s=1;
					}
					if(response == "t"+i)
					{
						self.tpnum = i;
						s=1;
					}
				}
				if(!s)
				{
					switch(response)
					{
					case "rm":
						self.rconitem = "";
						self.rconNum = 0;
						self.rconopened = 1;

						self thread refreshPlrList();
						self thread rconMsg("^2Only ^1ADMINS ^2can use Mini Rcon ^3!");
						break;
					case "crm":
						self notify("rconclosed");
						self.rconopened = undefined;
						break;
					case "c1":
						self.rconitem = "kick";
						break;
					case "c2":
						self.rconitem = "ban";
						break;
					case "c3":
						self.rconitem = "kill";
						break;
					case "all":
						self.rconNum = -1;
					case "ok":
						if(self.rconitem!="")
						{
							if(isdefined(self.rconNum) && (self.rconNum==-1 || isplayer(players[self.rconNum])))
							{
								if(self.rconNum==-1) all=1;
								else all=0;
								switch(self.rconitem)
								{
								case "kill":
									if(isdefined(self.pers["allowKill"]))
									{
										if(all) {self rconLogWrite("matou todos");for(i=0;i<players.size;i++) players[i] suicide(); }
										else { players[self.rconNum] suicide(); self rconLogWrite("matou "+players[self.rconNum].name); }
									}
									else
									{
										self CloseMenu();
										self closeInGameMenu();
										self.failpts++;
										self iprintlnbold(&"ER_ADM_NO");
									}
									break;
								case "ban":
									if(isdefined(self.pers["allowBan"]))
									{
										players[self.rconnum] thread ER_zumbis\_login::banuser(self.name);
										players[self.rconNum] kickplayer("^1Account banned ","", self);
										self rconLogWrite("banned account ->" +  players[self.rconNum].pers["login"] + "| Player -> " + players[self.rconNum].name);
									}
									else
									{
										self CloseMenu();
										self closeInGameMenu();
										self.failpts++;
										self iprintlnbold(&"ER_ADM_NO");
									}
									break;
								case "kick":
									if(isdefined(self.pers["allowKick"]))
									{
										players[self.rconNum] kickplayer("^1KICKADO","", self);
										self rconLogWrite("kickou "+players[self.rconNum].name);
									}
									else
									{
										self CloseMenu();
										self closeInGameMenu();
										self.failpts++;
										self iprintlnbold(&"ER_ADM_NO");
									}
									break;
								}
							}
							else
							{
								self rconMsg("Selecione alguem");
							}
						}
						else
						{
							self rconMsg("Selecione algo");
						}
					}
				}
			}
		}
		else if(menu == game["menu_serverinfo"])
		{
			if(response=="close") 
			{
			self closeMenu();
			self closeInGameMenu(); 
			}

			else if(response=="register")
				self openMenu("register");

			self.pers["skipserverinfo"] = true;
		}

				
		else if(!level.xenon)
		{
			     if(menu == game["menu_quickcommands"])maps\mp\gametypes\_quickmessages::quickcommands(response);
			else if(menu == game["menu_quickstatements"])maps\mp\gametypes\_quickmessages::quickstatements(response);
			else if(menu == game["menu_quickresponses"])maps\mp\gametypes\_quickmessages::quickresponses(response);		
			else if(menu == "loja1")ER_zumbis\_loja::loja1(response);			
			else if(menu == "loja2")ER_zumbis\_loja::loja2(response);
            else if(menu == "weaponloja")ER_zumbis\_loja::weaponloja(response);
			
            if(response == "3dv"){fovOn = undefined;if(!isdefined(self.fovOn)){self.fovOn = false;}
            if(self.fovOn){self.fovOn = false;self setclientcvar("cg_fov", 80);}
			else{self.fovOn = true;self setclientcvar("cg_fov", 110);}}			
            if(response == "thirdperson"){thirdpersonOn = undefined;if(!isdefined(self.thirdperson)){self.thirdperson = false;}
            if(self.thirdperson){self.thirdperson = false;self setclientcvar("cg_thirdperson", 0);}
			else{self.thirdperson = true;self setclientcvar("cg_thirdperson", 1);}}
			if(response == "fxoff"){enableOn = undefined;if(!isdefined(self.enable)){self.enable = false;}
            if(self.enable){self.enable = false;self setclientcvar("fx_enable", 1);}
			else{self.enable = true;self setclientcvar("fx_enable", 0);}}

			
			
		}
	}
}

refreshPlrList()
{
	self endon("rconclosed");
	self endon("disconnect");
	for(;;)
	{
		if(!isdefined(self.rconopened))
			break;
		players = getentarray("player", "classname");
		str = "";
		for(i=0;i<32;i++)
		{
		wait 0.05;
			if(i>=players.size)
				break;

			// ID coloring
			if(players[i].pers["team"]=="spectator")
				str+="^5";
			else if(!isalive(players[i]))
				str+="^1";
			else if(players[i].pers["team"]=="axis")
				str+="^9";
			else str+="^8";

			str += i + "^7: " + players[i].name + "\n";
		}
		self setClientCvar("ui_ids", str);
		if(players.size>=32)
		{
			str = "";
			for(i=32;i<players.size;i++)
			{
				// ID coloring
				if(players[i].pers["team"]=="spectator")
					str+="^5";
				else if(!isalive(players[i]))
					str+="^1";
				else if(players[i].pers["team"]=="axis")
					str+="^9";
				else str+="^8";

				str += i + ": " + players[i].name + "\n";
			}
			self setClientCvar("ui_ids2", str);
		}

		wait 0.1;
	}
}
rconMsg(msg)
{
	self notify("rconmsgstarted");
	self endon("disconnect");
	self endon("rconmsgstarted");
	self setclientcvar("a_r",msg);
	wait 3;
	for(i=0;i<msg.size-1;i++)
	{
		msg=getsubstr(msg,0,msg.size-1);
		self setclientcvar("a_r",msg);
		wait 0.05;
	}
	self setclientcvar("a_r","");
}
rconLogWrite(text)
{
	f=openfile("rconlog.rlog","append");
	if(f==-1) return;
	text=ER_zumbis\_ER_utils::monotone(text);
	fprintln(f,"\n"+self.pers["login"]+", name "+ER_zumbis\_ER_utils::monotone(self.name)+": "+text);
	closefile(f);
}
