main()
{
	if(!isdefined(level._effect))
		level._effect=[];
	level.callbackStartGameType = ::Callback_StartGameType;
	level.callbackPlayerConnect = ::Callback_PlayerConnect;
	level.callbackPlayerDisconnect = ::Callback_PlayerDisconnect;
	level.callbackPlayerDamage = ::Callback_PlayerDamage;
	level.callbackPlayerKilled = ::Callback_PlayerKilled;
	maps\mp\gametypes\_callbacksetup::SetupCallbacks();
	thread ER_zumbis\_mapvote::init();

	level.autoassign = ::zomMenuAutoAssign;
	level.allies = ::menuAllies;
	level.axis = ::menuAxis;
	level.spectator = ::menuSpectator;
	level.weapon = ::menuWeapon;
	level.endgameconfirmed = ::endMap;
}

Callback_StartGameType()
{
	level.splitscreen = isSplitScreen();

	// defaults if not defined in level script
	if(!isDefined(game["allies"]))
		game["allies"] = "american";
	if(!isDefined(game["axis"]))
		game["axis"] = "german";

	// server cvar overrides
	if(getCvar("scr_allies") != "")
		game["allies"] = getCvar("scr_allies");
	if(getCvar("scr_axis") != "")
		game["axis"] = getCvar("scr_axis");

	precacheStatusIcon("hud_status_dead");
	precacheStatusIcon("hud_status_connecting");
	precacheRumble("damage_heavy");
	precacheString(&"PLATFORM_PRESS_TO_SPAWN");
	setCvar( "download", "^2MoD By : ^6ER" );

	thread maps\mp\gametypes\_menus::init();
	thread maps\mp\gametypes\_serversettings::init();
	thread maps\mp\gametypes\_clientids::init();
	thread maps\mp\gametypes\_teams::init();
	thread maps\mp\gametypes\_weapons::init();
	thread maps\mp\gametypes\_scoreboard::init();
	thread maps\mp\gametypes\_killcam::init();
	thread maps\mp\gametypes\_shellshock::init();
	thread maps\mp\gametypes\_deathicons::init();
	thread maps\mp\gametypes\_damagefeedback::init();
	thread maps\mp\gametypes\_healthoverlay::init();
	thread maps\mp\gametypes\_friendicons::init();
	thread maps\mp\gametypes\_spectating::init();
	thread maps\mp\gametypes\_grenadeindicators::init();
	thread ER_zumbis\_ER::init();
	thread maps\mp\gametypes\_weapons::RemoveMG();
	thread ER_zumbis\_ranks::init();
	//thread ER_zumbis\_spectkick::init();

	level.xenon = (getcvar("xenonGame") == "true");
	if(level.xenon) // Xenon only
		thread maps\mp\gametypes\_richpresence::init();
	else // PC only
	thread maps\mp\gametypes\_quickmessages::init();		

	setClientNameMode("auto_change");

	spawnpoints = getentarray("mp_tdm_spawn", "classname");

	if(!spawnpoints.size)
	{
		spawnpoints = getentarray("mp_dm_spawn", "classname");
		if(!spawnpoints.size)
		{
			maps\mp\gametypes\_callbacksetup::AbortLevel();
			return;
		}
	}

	for(i = 0; i < spawnpoints.size; i++)
		spawnpoints[i] placeSpawnpoint();

	allowed[0] = "tdm";
	maps\mp\gametypes\_gameobjects::main(allowed);

	// Time limit per map
	if(getCvar("scr_zom_timelimit") == "")
		setCvar("scr_zom_timelimit", "30");
	else if(getCvarFloat("scr_zom_timelimit") > 1440)
		setCvar("scr_zom_timelimit", "1440");
	level.timelimit = getCvarFloat("scr_zom_timelimit");
	setCvar("ui_zom_timelimit", level.timelimit);
	makeCvarServerInfo("ui_zom_timelimit", "30");

	// Score limit per map
	if(getCvar("scr_zom_scorelimit") == "")
		setCvar("scr_zom_scorelimit", "1000");
	level.scorelimit = getCvarInt("scr_zom_scorelimit");
	setCvar("ui_zom_scorelimit", level.scorelimit);
	makeCvarServerInfo("ui_zom_scorelimit", "300");

	if(getCvar("scr_zom_scorelimit") == "")
		setCvar("scr_zom_scorelimit", "100");	

	// Force respawning
	if(getCvar("scr_forcerespawn") == "")
		setCvar("scr_forcerespawn", "0");

	if(!isDefined(game["state"]))
		game["state"] = "playing";

	level.mapended = false;

	level.team["allies"] = 0;
	level.team["axis"] = 0;

	thread startGame();
	thread ER_zumbis\_ER::TimeToEnd();
	thread ER_zumbis\_ER::checkCountdown();
	thread updateGametypeCvars();

	//if(getcvarint("developer"))
	//thread maps\mp\gametypes\_teams::addTestClients();
}

dummy()
{
	waittillframeend;

	if(isdefined(self))
		level notify("connecting", self);
}

Callback_PlayerConnect()
{
	thread dummy();

	self.statusicon = "hud_status_connecting";
	self waittill("begin");
	self.statusicon = "";

	level notify("connected", self);

	if(!level.splitscreen)
		iprintln(&"MP_CONNECTED", self);

	lpselfnum = self getEntityNumber();
	lpGuid = self getGuid();
	logPrint("J;" + lpGuid + ";" + lpselfnum + ";" + self.name + "\n");

	if(game["state"] == "intermission")
	{
		spawnIntermission();
		return;
	}

	level endon("intermission");

	scriptmainmenu="";
	if(isDefined(self.pers["team"]) && self.pers["team"] != "spectator")
	{
		self setClientCvar("ui_allow_weaponchange", "1");

		if(self.pers["team"] == "allies")
			self.sessionteam = "allies";
		else
			self.sessionteam = "axis";

		if(isDefined(self.pers["weapon"]))
			spawnPlayer();
		else
		{
			spawnSpectator();

			if(self.pers["team"] == "allies")
			{
				self openMenu(game["menu_weapon_allies"]);
				scriptMainMenu = game["menu_weapon_allies"];
				self thread ER_zumbis\_ER::nospawn();
			}
			else
			{
				self openMenu(game["menu_weapon_axis"]);
				scriptMainMenu = game["menu_weapon_axis"];
			}
		}
	}
	else
	{
		self setClientCvar("ui_allow_weaponchange", "0");

		self openMenu(game["menu_serverinfo"]);
		scriptMainMenu = game["menu_serverinfo"];
 
		self.pers["team"] = "spectator";
		self.sessionteam = "spectator";

		spawnSpectator();
	}

	self setClientCvar("g_scriptMainMenu", scriptMainMenu);
}

Callback_PlayerDisconnect()
{
	if(!level.splitscreen)
		iprintln(&"MP_DISCONNECTED", self);


	//Paulus - Changed team number to unique (2nd argument)
	if(isdefined(self.pers["team"]))
	{
		if(self.pers["team"] == "allies")
			setplayerteamrank(self, self.clientid, 0);
		else if(self.pers["team"] == "axis")
			setplayerteamrank(self, self.clientid, 0);
		else if(self.pers["team"] == "spectator")
			setplayerteamrank(self, self.clientid, 0);
	}

	lpselfnum = self getEntityNumber();
	lpGuid = self getGuid();
	logPrint("Q;" + lpGuid + ";" + lpselfnum + ";" + self.name + "\n");

	self notify("killed_player");
		//Decided to add this so that anything
		//that should be cleaned up on death will be cleaned up when someone leaves
		//e.g. Objective Pointers
}

Callback_PlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
/******************************************retorna damage******************************************************************************/
if(isDefined(self.spawnprotected) && self.spawnprotected)
		return;
		
 if(isPlayer(eAttacker) && eAttacker.pers["team"] == "spectator")
{
if(sWeapon == "frag_grenade_american_mp" 
|| sWeapon == "frag_grenade_british_mp" 
|| sWeapon == "frag_grenade_russian_mp"  
|| sWeapon == "frag_grenade_german_mp")
        return;
}		
				
if(isPlayer(eAttacker) && self.pers["team"] == "allies" && eAttacker == self)
{
if(sWeapon == "frag_grenade_american_mp" 
|| sWeapon == "frag_grenade_british_mp" 
|| sWeapon == "frag_grenade_russian_mp"  
|| sWeapon == "myball_mp"
|| sWeapon == "ercrossbow_mp"
|| sWeapon == "erRocket_mp"
|| sWeapon == "er_tnt")
        return;
}
/************************************************fim retorna damage************************************************************************/
	// Don't do knockback if the damage direction was not specified
	if(!isDefined(vDir))
		iDFlags |= level.iDFLAGS_NO_KNOCKBACK;

	friendly = undefined;

	// check for completely getting out of the damage
	if(!(iDFlags & level.iDFLAGS_NO_PROTECTION))
	{
		if(isPlayer(eAttacker) && self != eAttacker && self.pers["team"] == eAttacker.pers["team"])
		{
			if(level.friendlyfire == "0")
			{
				return;
			}
			else if(level.friendlyfire == "1")
			{
				// Make sure at least one point of damage is done
				if(iDamage < 1)
					iDamage = 1;

				self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

				// Shellshock/Rumble
				self thread maps\mp\gametypes\_shellshock::shellshockOnDamage(sMeansOfDeath, iDamage);
				self playrumble("damage_heavy");
			}
			else if(level.friendlyfire == "2")
			{
				eAttacker.friendlydamage = true;

				iDamage = int(iDamage * .5);

				// Make sure at least one point of damage is done
				if(iDamage < 1)
					iDamage = 1;

				eAttacker finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
				eAttacker.friendlydamage = undefined;

				friendly = true;
			}
			else if(level.friendlyfire == "3")
			{
				eAttacker.friendlydamage = true;

				iDamage = int(iDamage * .5);

				// Make sure at least one point of damage is done
				if(iDamage < 1)
					iDamage = 1;

				self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
				eAttacker finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
				eAttacker.friendlydamage = undefined;

				// Shellshock/Rumble
				self thread maps\mp\gametypes\_shellshock::shellshockOnDamage(sMeansOfDeath, iDamage);
				self playrumble("damage_heavy");

				friendly = true;
			}
		}
		else
		{
			// Make sure at least one point of damage is done
			if(iDamage < 1)
				iDamage = 1;

			self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

			// Shellshock/Rumble
			self thread maps\mp\gametypes\_shellshock::shellshockOnDamage(sMeansOfDeath, iDamage);
			self playrumble("damage_heavy");
		}

		if(isdefined(eAttacker) && eAttacker != self)
			eAttacker thread maps\mp\gametypes\_damagefeedback::updateDamageFeedback();
	}

	// Do debug print if it's enabled
	if(getCvarInt("g_debugDamage"))
	{
		println("client:" + self getEntityNumber() + " health:" + self.health +
			" damage:" + iDamage + " hitLoc:" + sHitLoc);
	}

	if(self.sessionstate != "dead")
	{
		lpselfnum = self getEntityNumber();
		lpselfname = self.name;
		lpselfteam = self.pers["team"];
		lpselfGuid = self getGuid();
		lpattackerteam = "";

		if(isPlayer(eAttacker))
		{
			lpattacknum = eAttacker getEntityNumber();
			lpattackGuid = eAttacker getGuid();
			lpattackname = eAttacker.name;
			lpattackerteam = eAttacker.pers["team"];
		}
		else
		{
			lpattacknum = -1;
			lpattackGuid = "";
			lpattackname = "";
			lpattackerteam = "world";
		}

		if(isDefined(friendly))
		{
			lpattacknum = lpselfnum;
			lpattackname = lpselfname;
			lpattackGuid = lpselfGuid;
		}

		logPrint("D;" + lpselfGuid + ";" + lpselfnum + ";" + lpselfteam + ";" + lpselfname + ";" + lpattackGuid + ";" + lpattacknum + ";" + lpattackerteam + ";" + lpattackname + ";" + sWeapon + ";" + iDamage + ";" + sMeansOfDeath + ";" + sHitLoc + "\n");
	}
}


Callback_PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	self endon("spawned");
	self notify("killed_player");

	noRespawn=false;

	if(getcvarint("scr_zom_"+self.pers["team"]+"DropWeapons"))
	{
		self maps\mp\gametypes\_weapons::dropWeapon();
		self maps\mp\gametypes\_weapons::dropOffhand();
	}

	self.sessionstate = "dead";
	self.statusicon = "hud_status_dead";

	if(!isdefined(self.switching_teams))
		self.deaths++;
		self notify("death");

	lpselfnum = self getEntityNumber();
	lpselfname = self.name;
	lpselfguid = self getGuid();
	lpselfteam = self.pers["team"];
	lpattackerteam = "";

	attackerNum = -1;
	if(isPlayer(attacker))
	{
		if(attacker == self) // killed himself
		{
			doKillcam = false;

			// switching teams
			if(isdefined(self.switching_teams))
			{
				if((self.leaving_team == "allies" && self.joining_team == "axis") || (self.leaving_team == "axis" && self.joining_team == "allies"))
				{
					players = maps\mp\gametypes\_teams::CountPlayers();
					players[self.leaving_team]--;
					players[self.joining_team]++;

					//if((players[self.joining_team] - players[self.leaving_team]) > 1)
					//	attacker.score--;
				}
			}

			if(!isdefined(self.switching_teams) || (isdefined(self.switching_teams) && self.switching_teams==false)) //|| isdefined(attacker.friendlydamage))
			{
				//if(isdefined(attacker.friendlydamage))
				//	attacker iprintln(&"MP_FRIENDLY_FIRE_WILL_NOT");

				//Killed himself and NOT switching teams so...
				if (self.pers["team"] == "allies")
				{
					self thread ER_zumbis\_ER::movePlayer("axis",GetCvarInt("scr_zom_tktimeout"));
					noRespawn = true;

					//LAST MAN STANDING
					if(level.lastman)
					{
						if (!(thread ER_zumbis\_ER::checkRestart(self)))
						{
							self thread ER_zumbis\_ER::blackScreen("alliedSuicide");
						}
					}
					else
					{
							self thread ER_zumbis\_ER::blackScreen("alliedSuicide");
					}
				}
				else
				{
					self thread ER_zumbis\_ER::movePlayer("axis",GetCvarInt("scr_zom_tktimeout"));
					noRespawn = true;

					//dont do blackscreen if the gametype is last man standing and round is restarting
					if(!(level.lastman && thread ER_zumbis\_ER::checkRestart(self)))
						self thread ER_zumbis\_ER::blackScreen("axisSuicide");
				}
			}
		}
		else
		{
			attackerNum = attacker getEntityNumber();
			doKillcam = true;
			
			if(self.pers["team"] == "axis")self playsound("zom_death");

			if(self.pers["team"] == attacker.pers["team"]) // killed by a friendly
			{
				attacker.score--; ///Changed from -5
///
				if(isdefined(attacker.friendlydamage))
					attacker iprintln(&"MP_FRIENDLY_FIRE_WILL_NOT");
///
				if (attacker.pers["team"] == "allies")
				{
					//If attacker is allied, make him a Zombie
					attacker thread ER_zumbis\_ER::movePlayer("axis",GetCvarInt("scr_zom_tktimeout"));
					noRespawn = true;
					//dont do blackscreen if the gametype is last man standing and round is restarting
					if(!(level.lastman && thread ER_zumbis\_ER::checkRestart(self))) //made it so victim becomes zombie
						attacker thread ER_zumbis\_ER::blackScreen("alliedTK");
				}
				else
				{
					//attacker is a zombie, reset his killcount
					attacker.killcount=0;
					attacker thread ER_zumbis\_ER::movePlayer("axis",GetCvarInt("scr_zom_tktimeout"));
					noRespawn = true;
					//dont do blackscreen if the gametype is last man standing and round is restarting
					if(!(level.lastman && thread ER_zumbis\_ER::checkRestart(self))) //made it so victim becomes zombie
						attacker thread ER_zumbis\_ER::blackScreen("axisTK");
				}
			}
			else
			{
				if(attacker.pers["team"] == "axis") attacker playsound("zum_attack");
				if (self.pers["team"] == "allies")
				{
					//allied killed by axis..allied becomes zombie	

					self thread ER_zumbis\_ER::movePlayer("axis",3);
					noRespawn = true;
					doKillcam=false;

					//LAST MAN STANDING
					if(level.lastman)
					{
						attacker.score++;
						if (!(thread ER_zumbis\_ER::checkRestart(self)))
						{
							self thread ER_zumbis\_ER::blackScreen("killed");
						}
					}
					else
					{
						self thread ER_zumbis\_ER::blackScreen("killed");

						attacker.killcount++;
						//attacker.score++;

						if (attacker.killcount > GetCvarInt("scr_zom_returnkills")-1)
						{
							attacker thread ER_zumbis\_ER::blackScreen("return");
							attacker thread ER_zumbis\_ER::movePlayer("allies",3);
							wait 0.01;
							thread ER_zumbis\_ER::checkRestart();

							noRespawn = true;
						}
					}
				}
				else
				{
					//axis killed by allied
				
			    if (GetCvarInt("scr_zom_alliesPointsForKilling") > 0)
				{
				attacker.score = attacker.score + GetCvarInt("scr_zom_alliesPointsForKilling");
				attacker checkScoreLimit();
				}
				}

				//attacker.score++;
				//teamscore = getTeamScore(attacker.pers["team"]);
				//teamscore++;
				//setTeamScore(attacker.pers["team"], teamscore);
			}
		}
		lpattacknum = attacker getEntityNumber();
		lpattackguid = attacker getGuid();
		lpattackname = attacker.name;
		lpattackerteam = attacker.pers["team"];
	}
	else // If you weren't killed by a player, you were in the wrong place at the wrong time
	{
		doKillcam = false;

		self.score--;

		lpattacknum = -1;
		lpattackname = "";
		lpattackguid = "";
		lpattackerteam = "world";

		if(self.pers["team"] == "allies")
		{
			//If you are allied, become a Zombie
			self thread ER_zumbis\_ER::movePlayer("axis",GetCvarInt("scr_zom_tktimeout"));
			noRespawn = true;


			//LAST MAN STANDING
			if(!(level.lastman && thread ER_zumbis\_ER::checkRestart(self)))
			self.pers["totdeaths"]--;
				self thread ER_zumbis\_ER::blackScreen("alliedSuicide");
		}
		else
		{
			//you are a zombie, reset killcount
			self.killcount=0;
			self thread ER_zumbis\_ER::movePlayer("axis",GetCvarInt("scr_zom_tktimeout"));
			noRespawn = true;
			if(!(level.lastman && thread ER_zumbis\_ER::checkRestart(self)))
			self.pers["totdeaths"]--;
				self thread ER_zumbis\_ER::blackScreen("axisSuicide");
		}
	}

	level notify("update_teamscore_hud");

	logPrint("K;" + lpselfguid + ";" + lpselfnum + ";" + lpselfteam + ";" + lpselfname + ";" + lpattackguid + ";" + lpattacknum + ";" + lpattackerteam + ";" + lpattackname + ";" + sWeapon + ";" + iDamage + ";" + sMeansOfDeath + ";" + sHitLoc + "\n");

	// Stop thread if map ended on this death
	if(level.mapended)
		return;

	//dont show body if you have suicided (been forced to switch teams)
	//if(isdefined(self.joining_team) && isdefined(self.leaving_team) && (self.joining_team!=self.leaving_team))
	//{	
	    playfx(level._effect["gib"],self.origin+(0,0,11));
	    playfx(level._effect["gib2"],self.origin+(0,0,11));		
	//body = self cloneplayer(deathAnimDuration);
	//thread maps\mp\gametypes\_deathicons::addDeathicon(body, self.clientid, self.pers["team"], 5);
	//}	

	self.switching_teams = undefined;
	self.joining_team = undefined;
	self.leaving_team = undefined;

	delay = 2;	// Delay the player becoming a spectator till after he's done dying
	wait delay;	// ?? Also required for Callback_PlayerKilled to complete before respawn/killcam can execute


	if(doKillcam && level.killcam)
		self maps\mp\gametypes\_killcam::killcam(attackerNum, delay, psOffsetTime, true);

	if(!noRespawn)
		self thread respawn();
}

spawnPlayer()
{
	if(!isdefined(self.pers["weapon"]) || !self.pers["loggedin"]) return;
	if(self.delayed)
		self waittill("joined_team");

	self endon("disconnect");
	self notify("spawned");
	self notify("end_respawn");

	resettimeout();

	// Stop shellshock and rumble
	self stopShellshock();
	self stoprumble("damage_heavy");

	self.sessionteam = self.pers["team"];
	self.sessionstate = "playing";
	self.spectatorclient = -1;
	self.archivetime = 0;
	self.psoffsettime = 0;
	self.statusicon = "";
	self.friendlydamage = undefined;

	spawnpointname = "mp_tdm_spawn";
	spawnpoints = getentarray(spawnpointname, "classname");
	spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_NearTeam(spawnpoints);

	if(isDefined(spawnpoint))
		self spawn(spawnpoint.origin, spawnpoint.angles);
	else
		maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");

	if(!isDefined(self.pers["savedmodel"]))
		maps\mp\gametypes\_teams::model();
	else
		maps\mp\_utility::loadModel(self.pers["savedmodel"]);
		

	self giveWeapon(self.pers["weapon"]);
	self giveMaxAmmo(self.pers["weapon"]);
	self setSpawnWeapon(self.pers["weapon"]);

	self thread ER_zumbis\_ER::spawnPlayer();

	waittillframeend;
	self notify("spawned_player");
	
    if(GetCvarint("scr_spawnprotection" == "1" ))
	self thread spwpro();
  
}
spwpro()
{
    self.spawnprotected = 1;
    if(isdefined(self.protmodel ))self.protmodel delete();
    self.protmodel = spawn("script_model", self.origin + (0,0,80));		
    self.protmodel setmodel("xmodel/bunker_ceiling_light_on");	
    self.protmodel linkto(self);
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_off");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_on");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_off");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_on");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_off");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_on");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_off");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_on");
	wait .5;
	self.protmodel setmodel("xmodel/bunker_ceiling_light_off");
	
	self.spawnprotected = 0;
	if(isdefined(self.protmodel ))self.protmodel delete();
}
spawnSpectator(origin, angles)
{
	self notify("spawned");
	self notify("end_respawn");

	resettimeout();

	SpectatorSpawned();

	// Stop shellshock and rumble
	self stopShellshock();
	self stoprumble("damage_heavy");

	self.sessionstate = "spectator";
	self.spectatorclient = -1;
	self.archivetime = 0;
	self.psoffsettime = 0;
	self.friendlydamage = undefined;

	if(self.pers["team"] == "spectator")
		self.statusicon = "";

	maps\mp\gametypes\_spectating::setSpectatePermissions();

	if(isDefined(origin) && isDefined(angles))
		self spawn(origin, angles);
	else
	{
		spawnpointname = "mp_global_intermission";
		spawnpoints = getentarray(spawnpointname, "classname");
		spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random(spawnpoints);

		if(isDefined(spawnpoint))
			self spawn(spawnpoint.origin, spawnpoint.angles);
		// else
			// maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");
	}

	self setClientCvar("cg_objectiveText", "");
}

spawnIntermission()
{
	self notify("spawned");
	self notify("end_respawn");

	resettimeout();

	// Stop shellshock and rumble
	self stopShellshock();
	self stoprumble("damage_heavy");

	self.sessionstate = "intermission";
	self.spectatorclient = -1;
	self.archivetime = 0;
	self.psoffsettime = 0;
	self.friendlydamage = undefined;

	spawnpointname = "mp_global_intermission";
	spawnpoints = getentarray(spawnpointname, "classname");
	spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random(spawnpoints);

	if(isDefined(spawnpoint))
		self spawn(spawnpoint.origin, spawnpoint.angles);
	else
		maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");
}

respawn()
{
	if(!isDefined(self.pers["weapon"]))
		return;

	self endon("end_respawn");

	if(getCvarInt("scr_forcerespawn") <= 0)
	{
		self thread waitRespawnButton();
		self waittill("respawn");
	}

	self thread spawnPlayer();
}

waitRespawnButton()
{
	self endon("disconnect");
	self endon("end_respawn");
	self endon("respawn");

	wait 0; // Required or the "respawn" notify could happen before it's waittill has begun
	if(isalive(self)) return;
	if(isDefined(self.respawntext))
		self.respawntext destroy();
	self.respawntext = newClientHudElem(self);
	self.respawntext.horzAlign = "center_safearea";
	self.respawntext.vertAlign = "center_safearea";
	self.respawntext.alignX = "center";
	self.respawntext.alignY = "middle";
	self.respawntext.x = 0;
	self.respawntext.y = -50;
	self.respawntext.archived = false;
	self.respawntext.font = "default";
	self.respawntext.fontscale = 2;
	self.respawntext setText(&"PLATFORM_PRESS_TO_SPAWN");

	thread removeRespawnText();
	thread waitRemoveRespawnText("end_respawn");
	thread waitRemoveRespawnText("respawn");

	while(self useButtonPressed() != true)
		wait .05;

	self notify("remove_respawntext");

	self notify("respawn");
}

removeRespawnText()
{
	self waittill("remove_respawntext");

	if(isDefined(self.respawntext))
		self.respawntext destroy();
}

waitRemoveRespawnText(message)
{
	self endon("remove_respawntext");

	self waittill(message);
	self notify("remove_respawntext");
}

startGame()
{
  
	level.starttime = getTime();

	if(level.timelimit > 0)
	{
		level.clock = newHudElem();
		level.clock.horzAlign = "left";
		level.clock.vertAlign = "top";
		level.clock.x = 310;
		level.clock.y = 450;
		level.clock.font = "default";
		level.clock.fontscale = 1.7;
		level.clock.color =(0,1,0);
		level.clock setTimer(level.timelimit * 60);
	}

	for(;;)
	{
		checkTimeLimit();
		wait 1;
	}
}

endMap()
{
   level notify("stop_now");
   thread ER_zumbis\_mapvote::Initialize();
   level waittill("VotingComplete");

	game["state"] = "intermission";
	level notify("intermission");

	players = getentarray("player", "classname");
	highscore = undefined;
	tied = undefined;
	playername = undefined;
	name = undefined;
	guid = undefined;

	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(player.pers["team"]) && player.pers["team"] == "spectator")
			continue;

		if(!isdefined(highscore))
		{
			highscore = player.score;
			playername = player;
			name = player.name;
			guid = player getGuid();
			continue;
		}

		if(player.score == highscore)
			tied = true;
		else if(player.score > highscore)
		{
			tied = false;
			highscore = player.score;
			playername = player;
			name = player.name;
			guid = player getGuid();
		}
	}

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		player closeMenu();
		player closeInGameMenu();

		if(isdefined(tied) && tied == true)
			player setClientCvar("cg_objectiveText", &"MP_THE_GAME_IS_A_TIE");
		else if(isdefined(playername))
			player setClientCvar("cg_objectiveText", &"MP_WINS", playername);

		player spawnIntermission();
	}

	if(isdefined(name))
		logPrint("W;;" + guid + ";" + name + "\n");

	// set everyone's rank on xenon
	if(level.xenon)
	{
		for(i = 0; i < players.size; i++)
		{
			player = players[i];

			if(isdefined(player.pers["team"]) && player.pers["team"] == "spectator")
				continue;

			if(highscore <= 0)
				rank = 0;
			else
			{
				rank = int(player.score * 10 / highscore);
				if(rank < 0)
					rank = 0;
			}

			// since DM is a free-for-all, give every player their own team number
			setplayerteamrank(player, player.clientid, rank);
		}
		sendranks();
	}

	wait 8;
	setcvar("sv_maprotationcurrent","map "+level.nextmap);
	exitLevel(false);
}

checkTimeLimit()
{
	if(level.timelimit <= 0)
		return;
		

	timepassed = (getTime() - level.starttime) / 1000;
	timepassed = timepassed / 60.0;

	if(timepassed < level.timelimit)
		return;

	if(level.mapended)
		return;
	level.mapended = true;

	if(!level.splitscreen)
		iprintln(&"MP_TIME_LIMIT_REACHED");

	level thread endMap();
}

checkScoreLimit()
{

	waittillframeend;

	if(level.scorelimit <= 0)
		return;

	if (!isDefined(self.score))
		return;

	if(self.score < level.scorelimit)
		return;

	if(level.mapended)
		return;
	level.mapended = true;

	if(!level.splitscreen)
		iprintln(&"MP_SCORE_LIMIT_REACHED");

	level thread endMap();

}

updateGametypeCvars()
{
	for(;;)
	{
		timelimit = getCvarFloat("scr_zom_timelimit");
		if(level.timelimit != timelimit)
		{
			if(timelimit > 1440)
			{
				timelimit = 1440;
				setCvar("scr_zom_timelimit", "1440");
			}

			level.timelimit = timelimit;
			setCvar("ui_zom_timelimit", level.timelimit);
			level.starttime = getTime();

			if(level.timelimit > 0)
			{
				if(!isDefined(level.clock))
				{
					level.clock = newHudElem();
					level.clock.horzAlign = "left";
					level.clock.vertAlign = "top";
					level.clock.x = 310;
					level.clock.y = 450;
					level.clock.font = "default";
					level.clock.fontscale = 1.7;
				}
				level.clock setTimer(level.timelimit * 60);
			}
			else
			{
				if(isDefined(level.clock))
					level.clock destroy();
			}

			checkTimeLimit();
		}

		scorelimit = getCvarInt("scr_zom_scorelimit");
		if(level.scorelimit != scorelimit)
		{
			level.scorelimit = scorelimit;
			setCvar("ui_zom_scorelimit", level.scorelimit);
		}
		checkScoreLimit();

		wait 1;
	}
}

printJoinedTeam(team)
{
	if(!level.splitscreen)
	{
		if(team == "allies")
			iprintln(&"MP_JOINED_ALLIES", self);
		else if(team == "axis")
			iprintln(&"MP_JOINED_AXIS", self);
	}
}

menuAutoAssign()
{
//NOT USED!!!!
	if (isDefined(self.delayed) && self.delayed==true)
		return;

		if (getcvar("scr_zom_NoTeamChange")=="1" && (self.pers["team"] == "allies" || self.pers["team"] == "axis"))
		return;

	numonteam["allies"] = 0;
	numonteam["axis"] = 0;

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(!isDefined(player.pers["team"]) || player.pers["team"] == "spectator" || player == self)
			continue;

		numonteam[player.pers["team"]]++;
	}

	// if teams are equal return the team with the lowest score
	if(numonteam["allies"] == numonteam["axis"])
	{
		if(getTeamScore("allies") == getTeamScore("axis"))
		{
			teams[0] = "allies";
			teams[1] = "axis";
			assignment = teams[randomInt(2)];
		}
		else if(getTeamScore("allies") < getTeamScore("axis"))
			assignment = "allies";
		else
			assignment = "axis";
	}
	else if(numonteam["allies"] < numonteam["axis"])
		assignment = "allies";
	else
		assignment = "axis";

	if(assignment == self.pers["team"] && (self.sessionstate == "playing" || self.sessionstate == "dead"))
	{
	    if(!isdefined(self.pers["weapon"]))
	    {
		    if(self.pers["team"] == "allies")
			    self openMenu(game["menu_weapon_allies"]);
		    else
			    self openMenu(game["menu_weapon_axis"]);
	    }

		return;
	}

	if(assignment != self.pers["team"] && (self.sessionstate == "playing" || self.sessionstate == "dead"))
	{
		self.switching_teams = true;
		self.joining_team = assignment;
		self.leaving_team = self.pers["team"];
		self suicide();
	}

	self.pers["team"] = assignment;
	self.pers["weapon"] = undefined;
	self.pers["savedmodel"] = undefined;

	self setClientCvar("ui_allow_weaponchange", "1");

	if(self.pers["team"] == "allies")
	{
		self openMenu(game["menu_weapon_allies"]);
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_allies"]);
	}
	else
	{
		self openMenu(game["menu_weapon_axis"]);
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_axis"]);
	}

	self notify("joined_team");
	self notify("end_respawn");
}

menuAllies()
{
	if(self.pers["team"] != "allies")
	{
		if(self.sessionstate == "playing")
		{
			// Set a flag on the player to they aren't robbed points for dying - the callback will remove the flag
			self.switching_teams = true;
			self.joining_team = "allies";
			self.leaving_team = self.pers["team"];
			self suicide();
		}

		self.pers["team"] = "allies";
		self.pers["weapon"] = undefined;
		self.pers["savedmodel"] = undefined;
		ShowWeapons = true;

		self notify("joined_team");
		self notify("end_respawn");
	}
	else
	{
		ShowWeapons = false;
	}

	self ER_zumbis\_ER::blackScreenDelete();

	self closemenu();
	self closeingamemenu();
	if(ShowWeapons)
	{
		self setClientCvar("ui_allow_weaponchange", "1");

		self setClientCvar("g_scriptMainMenu", game["menu_weapon_allies"]);
		self openMenu(game["menu_weapon_allies"]);
	}

	self maps\mp\gametypes\_teams::updateTeamTime();

	self notify("joined_team");
	self notify("end_respawn");

	self thread maps\mp\gametypes\zom::respawn();
	self thread ER_zumbis\_ER::nospawn();
}

menuAxis()
{
	if(self.pers["team"] != "axis")
	{
		if(self.sessionstate == "playing")
		{
			self.switching_teams = true;
			self.joining_team = "axis";
			self.leaving_team = self.pers["team"];
			self suicide();
		}

		self.pers["team"] = "axis";
		self.pers["weapon"] = undefined;
		self.pers["savedmodel"] = undefined;
		ShowWeapons = true;

		self notify("joined_team");
		self notify("end_respawn");
	}
	else
	{
		ShowWeapons = false;
	}

	self ER_zumbis\_ER::blackScreenDelete();

	self closemenu();
	self closeingamemenu();
	if(ShowWeapons)
	{
		self setClientCvar("ui_allow_weaponchange", "1");

		self setClientCvar("g_scriptMainMenu", game["menu_weapon_axis"]);
		self openMenu(game["menu_weapon_axis"]);
	}

	self maps\mp\gametypes\_teams::updateTeamTime();

	self notify("joined_team");
	self notify("end_respawn");

	self thread maps\mp\gametypes\zom::respawn();
}

menuSpectator()
{
	if(self.pers["team"] != "spectator")
	{
		if(isAlive(self))
		{
			self.switching_teams = true;
			self.joining_team = "spectator";
			self.leaving_team = self.pers["team"];
			self suicide();
		}

		self.pers["team"] = "spectator";
		self.pers["weapon"] = undefined;
		self.pers["savedmodel"] = undefined;

		self.sessionteam = "spectator";
		self setClientCvar("ui_allow_weaponchange", "0");
		spawnSpectator();

		self setClientCvar("g_scriptMainMenu", game["menu_ingame"]);

		self notify("joined_spectators");
	}
}

menuWeapon(response)
{

	if (isDefined(self.delayed) && self.delayed==true)
		return;

	if(!isDefined(self.pers["team"]) || (self.pers["team"] != "allies" && self.pers["team"] != "axis"))
		return;

	weapon = self maps\mp\gametypes\_weapons::restrictWeaponByServerCvars(response);

	if(weapon == "restricted")
	{
		if(self.pers["team"] == "allies")
			self openMenu(game["menu_weapon_allies"]);
		else if(self.pers["team"] == "axis")
			self openMenu(game["menu_weapon_axis"]);

		return;
	}
	else if(weapon == "needbuy")
	{
		if(self.pers["team"] == "allies")
			self openMenu(game["menu_weapon_allies"]);
		else if(self.pers["team"] == "axis")
			self openMenu(game["menu_weapon_axis"]);

		if(self.pers["money"]>=level.weapons[response].price)
		{
			self setclientcvar("buyingWeapon",level.weapons[response].fullname);
			self.buyingwep=response;
			self openMenu("buywep");
		}
		else
		{
			if(self.english)
			{
				self setclientcvar("com_errorTitle","Not enough money");
				if(maps\mp\gametypes\_weapons::useAn(response))
					self setclientcvar("com_errorMessage","You can't buy an "+level.weapons[response].fullname);
				else
					self setclientcvar("com_errorMessage","You can't buy a "+level.weapons[response].fullname);
			}
			else
			{
				self setclientcvar("com_errorTitle","Nimas dovolj denarja");
				self setclientcvar("com_errorMessage","Nimas dovolj za "+level.weapons[response].fullname);
			}
			self openMenu("error2");
		}

		return;
	}
	else if(weapon == "needlvl")
	{
		if(self.pers["team"] == "allies")
			self openMenu(game["menu_weapon_allies"]);
		else if(self.pers["team"] == "axis")
			self openMenu(game["menu_weapon_axis"]);

		if(self.english)
		{
			self setclientcvar("com_errorTitle","Not high enough level");
			if(maps\mp\gametypes\_weapons::useAn(response))
				self setclientcvar("com_errorMessage","Not high enough for an "+level.weapons[response].fullname);
			else
				self setclientcvar("com_errorMessage","Not high enough for a "+level.weapons[response].fullname);
		}
		else
		{
			self setclientcvar("com_errorTitle","Nisi dovolj level");
			self setclientcvar("com_errorMessage","Nisi dovolj level za "+level.weapons[response].fullname);
		}
		self openMenu("error2");

		return;
	}

	if(level.splitscreen)
		self setClientCvar("g_scriptMainMenu", game["menu_ingame_onteam"]);
	else
		self setClientCvar("g_scriptMainMenu", game["menu_ingame"]);

	if(isDefined(self.pers["weapon"]) && self.pers["weapon"] == weapon)
		return;

	if(!isDefined(self.pers["weapon"]))
	{
		self.pers["weapon"] = weapon;
		spawnPlayer();
		self thread printJoinedTeam(self.pers["team"]);
	}
	else
	{
		self.pers["weapon"] = weapon;

		weaponname = maps\mp\gametypes\_weapons::getWeaponName(self.pers["weapon"]);

		if(maps\mp\gametypes\_weapons::useAn(self.pers["weapon"]))
			self iprintln(&"MP_YOU_WILL_RESPAWN_WITH_AN", weaponname);
		else
			self iprintln(&"MP_YOU_WILL_RESPAWN_WITH_A", weaponname);
	}

	self thread maps\mp\gametypes\_spectating::setSpectatePermissions();
}

SpectatorSpawned()
{
	self.delayed = false;

	if(level.lastman)
		thread ER_zumbis\_ER::checkRestart();
}


zomMenuAutoAssign()
{
	if(isDefined(self.delayed) && self.delayed==true)
		return;

		if(getcvar("scr_zom_NoTeamChange")=="1" && (self.pers["team"] == "allies" || self.pers["team"] == "axis"))
		return;

	if(level.lastman)
	{
		if(ER_zumbis\_ER::checkRestart(self))
		{
			return;
		}

		assignment = "axis";
	}
	else
	{
		numonteam["allies"] = 0;
		numonteam["axis"] = 0;

		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{
			player = players[i];

			if(!isDefined(player.pers["team"]) || player.pers["team"] == "spectator" || player == self)
				continue;

			numonteam[player.pers["team"]]++;
		}


		if(numonteam["allies"] == 0)
		{
			assignment = "allies";
		}
		else if (numonteam["axis"] == 0)
		{
			assignment = "axis";
		}
		else if (numonteam["allies"]/numonteam["axis"] > 0.4)
		{
			assignment = "axis";
		}
		else
		{
			assignment = "allies";
		}
	}

	if(assignment == self.pers["team"] && (self.sessionstate == "playing" || self.sessionstate == "dead"))
	{
	    if(!isdefined(self.pers["weapon"]))
	    {
		    if(self.pers["team"] == "allies")
			    self openMenu(game["menu_weapon_allies"]);
		    else
			    self openMenu(game["menu_weapon_axis"]);
	    }

		return;
	}

	if(assignment != self.pers["team"] && (self.sessionstate == "playing" || self.sessionstate == "dead"))
	{
		self.switching_teams = true;
		self.joining_team = assignment;
		self.leaving_team = self.pers["team"];
		self suicide();
	}

	self.pers["team"] = assignment;
	self.pers["weapon"] = undefined;
	self.pers["savedmodel"] = undefined;

	self setClientCvar("ui_allow_weaponchange", "1");

	if(self.pers["team"] == "allies")
	{
		self openMenu(game["menu_weapon_allies"]);
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_allies"]);
	}
	else
	{
		self openMenu(game["menu_weapon_axis"]);
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_axis"]);
	}

	self notify("joined_team");
	self notify("end_respawn");
}

ShowText(message,destroyOld, arg0)
{
	a=0;

	if(!isDefined(self.mess))
	{
		self.mess=[];
	}
	else
	{
		//Pick a non-existent message number
		for (i=0; i<10; i++)
		{
			if (isDefined(self.mess[i]))
			{
				//Destroy all if destroyOld is equal to 1
				if (isDefined(destroyOld) && destroyOld==1)
				{
					self.mess[i] destroy();
					continue;
				}

				if (i>9)
				{
					a=0;
					self.mess[0] destroy();
				}
				else
					continue;
			}
			else
			{
				//if detroyOld is true then we want to keep
				//looping no matter what so everything is destroyed
				if (isDefined(destroyOld) && destroyOld==1)
				{
					continue;
				}

				a=i;
				break;
			}
		}
	}

	self.mess[a] = newClientHudElem(self);
	self.mess[a].x = 320; //630
	self.mess[a].y = 475+(a*12);
	self.mess[a].alignX = "center";
	self.mess[a].alignY = "middle";
	self.mess[a].font = "bigfixed";
	self.mess[a].sort = 9999; //-3
	self.mess[a].alpha = 0;
	self.mess[a].fontScale = 0.625;
	self.mess[a].archived = false;

	if (isDefined(arg0))
	{
		self.mess[a].label = message;
		self.mess[a] setValue(arg0);
	}
	else
	{
		self.mess[a] setText(message);
	}

	self.mess[a] fadeOverTime(0.1);
	self.mess[a] moveOverTime(0.2);
	self.mess[a].alpha = 0.2;
	self.mess[a].y = 175+(a*12);

	self.mess[a] moveOverTime(0.2);
	self.mess[a] fadeOverTime(0.2);
	self.mess[a].alpha = 1;
	self.mess[a].y = 100+(a*12);

	wait 6;

	self.mess[a] fadeOverTime(2);
	self.mess[a].alpha = 0;

	//self.mess[a].y = -20;

	wait 3;

	self.mess[a] destroy();
}